# Filename:     tb_ad7813_sim.do
# Filetype:     Modelsim Script File
# Date:         23 sep 2012
# Update:       -
# Description:  Script File For Automatic Simulation
# Author:       J. op den Brouw
# State:        Demo
# Error:        -
# Version:      1.0
# Copyright:    (c)2012, De Haagse Hogeschool

# Set transcript on
transcript on

# Recreate the work directory and map to work
if {[file exists rtl_work]} {
	vdel -lib rtl_work -all
}
vlib rtl_work
vmap work rtl_work

# Find out if we're started through Quartus or by hand
# (or by using an exec in the Tcl window in Quartus).
# Quartus has the annoying property that it will start
# Modelsim from a directory called "simulation/modelsim".
# The design and the testbench are located in the project
# root, so we've to compensate for that.
if [ string match "*simulation/modelsim" [pwd] ] { 
	set prefix "../../"
	puts "Running Modelsim from Quartus..."
} else {
	set prefix ""
	puts "Running Modelsim..."
}

# Compile the AD7813 VHDL description and testbench,
# please note that the design and its testbench is located
# in the project root, but the simulator start in directory
# <project_root>/simulation/modelsim, so we have to compensate
# for that.
vcom -2008 -work work ${prefix}ad7813_module_sim.vhd
vcom -2008 -work work ${prefix}ad7813_sim.vhd
vcom -2008 -work work ${prefix}tb_ad7813_sim.vhd

# Start the simulator with 1 ns time resolution
vsim -t 1ns -L rtl_work -L work -voptargs="+acc" tb_ad7813_sim

# Log all signals in the design, good if the number
# of signals is small.
add log -r *

# Add all toplevel signals
# Add a number of signals of the simulated design
#add list *

# Add all toplevel signals
# Add a number of signals of the simulated design
add wave -divider "SYSTEM"
add wave CLOCK_50
add wave -divider "Inputs"
add wave SW
add wave BUTTON
add wave CONVST
add wave CS
add wave RD
add wave -divider "Internals"
add wave dut/ad7813/clk
add wave dut/ad7813/areset
add wave dut/ad7813/counter15us
add wave dut/ad7813/timer_state
add wave dut/ad7813/counter23us
add wave dut/ad7813/convst_int
add wave dut/ad7813/conversion_state
add wave dut/ad7813/busy_int
add wave dut/ad7813/dataread_state
add wave dut/ad7813/db_int
add wave -divider "Outputs"
#add wave LEDG
add wave BUSY
add wave DB

# Open Structure, Signals (waveform) and List window
view structure
#view list
view signals
view wave

# Run simulation for ...
run 100 us

# Fill up the waveform in the window
wave zoom full
